/*
 * socket.h
 */


#ifndef share_socket_h
#define share_socket_h


#ifndef ASM_FILE


enum{
	/* socket domain. */
	AF_INET=0,		/* Internet domain sockets for use with IPv4 addresses. */
	AF_INET6,		/* Internet domain sockets for use with IPv6 addresses. */
	AF_UNIX,		/* UNIX domain sockets. */
	AF_UNSPEC,		/* Unspecified. */

	/* socket type. */
	SOCK_DGRAM=0,	/* Datagram socket. */
	SOCK_RAW,		/* Raw Protocol Interface. */
	SOCK_SEQPACKET,	/* Sequenced-packet socket. */
	SOCK_STREAM,	/* Byte-stream socket. */

	/* recv  flags */
	MSG_CTRUNC= 1<<0,	/* Control data truncated. */
	MSG_EOR=    1<<1,	/* Terminates a record (if supported by the protocol). */
	MSG_OOB=    1<<2,	/* Out-of-band data. */
	MSG_PEEK=   1<<3,	/* Leave received data in queue. */
	MSG_TRUNC=  1<<4,	/* Normal data truncated. */
	MSG_WAITALL=1<<5,	/* Attempt to fill the read buffer. */

	/* shutdownΥե饰 */
	SHUT_RDWR=0,		/* Disables further send and receive operations. */
	SHUT_RD=0,		/* Disables further receive operations. */
	SHUT_WR,		/* Disables further send operations. */
};


typedef int          socklen_t;
typedef unsigned int sa_family_t;


struct sockaddr{
	sa_family_t  sa_family;		/* Address family. */
	char         sa_data[0];	/* Socket address (variable-length data). */
};


#endif


#endif
